unit UDemo;
{ Example for TXYSystem component }

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls, Forms,
  Dialogs, CommCtrl, ExtCtrls, AsyncTimer, XYSys, StdCtrls, ComCtrls;

type
  TTestForm = class(TForm)
	 Timer: TAsyncTimer;
	 BAnim: TButton;
	 BMath: TButton;
	 CBTrack: TCheckBox;
	 TrackBar: TTrackBar;
    Panel1: TPanel;
    XY: TXYSystem;
	 procedure TrackBarChange(Sender: TObject);
	 procedure TimerTimer(Sender: TObject);
	 procedure BMathClick(Sender: TObject);
	 procedure BAnimClick(Sender: TObject);
  private
	 i : integer;
  end;

var
  TestForm: TTestForm;

implementation

{$R *.DFM}


function f(x : double) : double;
begin
	f:= -0.8*sqr(x) + 0.16*sqr(sqr(x));
end;


procedure TTestForm.TrackBarChange(Sender: TObject);
begin
	 Timer.interval:= TrackBar.position;
end;

procedure TTestForm.TimerTimer(Sender: TObject);
begin     // draw some graphics:
	 With XY Do
		 begin
		 If not CBTrack.checked Then
			 begin
			 Canvas.Pen.color:= clBlack;
			 DrawPoint(2.5*cos(i/18), 1.3*sin(i/30));
			 end;
		 Inc(i);
		 Canvas.Pen.color:= clWhite;
		 DrawPoint(2.5*cos(i/18), 1.3*sin(i/30));
		 If i = 700 Then
			 begin RePaint; i:= 0; end;
		 end;
end;

procedure TTestForm.BMathClick(Sender: TObject);
begin
	Timer.enabled:= false;
	With XY do
		begin
		RePaint;         // draw math objects:
		Canvas.Pen.color:= clYellow;
		Canvas.Pen.width:= 1;
		DrawLine(1, 2, 1);
		DrawLine(2, -1, 0);
		pointRay:= 1;
		DrawPoint(Xmax, Ymin);
		Canvas.Pen.width:= 8;
		Vector(0, 0, -2, 1.6);
		Canvas.Pen.color:= clLime;
		Canvas.Pen.width:= 2;
		DrawFunc(f, -2.5, 2.5);
		end;
end;

procedure TTestForm.BAnimClick(Sender: TObject);
begin
	XY.Repaint;
	XY.pointRay:= 4;
	i:= 0;
	Timer.enabled:= not Timer.enabled;
end;

end.

